# -*- coding: utf-8 -*-

from artix.common.py2to3utils import configparser


class ConfKeeper(object):
    confObject = None


conf = ConfKeeper()


def __getConf(filenames):
    global conf
    confObject = configparser.RawConfigParser()
    isReaded = confObject.read(filenames)
    conf.confObject = confObject
    return isReaded


class FakeGlobalSectionHead(object):
    def __init__(self, fp):
        self.fp = fp
        self.sechead = '[global]\n'

    def readline(self):
        if self.sechead:
            try:
                return self.sechead
            finally:
                self.sechead = None
        else:
            return self.fp.readline()


def read(filenames):
    return __getConf(filenames)


def options(section):
    opts = []
    try:
        opts = conf.confObject.options(section)
    except:
        print("No section: '%s'. Return options - %s" % (section, opts))
    return opts


def set(section, option, value):
    return conf.confObject.set(section, option, value)


def getBool(section, option, defaultValue):
    value = defaultValue
    try:
        value = conf.confObject.getboolean(section, option)
    except:
        pass
    return value


def getInt(section, option, defaultValue):
    value = defaultValue
    try:
        value = conf.confObject.getint(section, option)
    except:
        pass
    return value


def getString(section, option, defaultValue):
    value = defaultValue
    try:
        value = conf.confObject.get(section, option)
    except:
        pass
    return value


def getSection(sectionName, defaultValue=''):
    section = options(sectionName)
    sectionMap = {}
    
    for m in section:
        sectionMap[m] = getString(sectionName, m, defaultValue)
    
    return sectionMap

