# -*- coding: UTF-8 -*-

import time as Time
from datetime import date as Date
from datetime import datetime


class SafeDict(dict):
    def __missing__(self, key):
        return '%(' + key + ')s'


def applyMacrosWithoutTime(string, log, **args):
    if isinstance(string, str):
        for key in list(args):
            vars()[key] = args[key]
        try:
            cashcode_int = int(args['cashcode'])
        except Exception as e:
            log.debug(u'Не удалось получить код кассы(cashcode_int). Ошибка: %s' % (e))
        try:
            shopcode_int = int(args['shopcode'])
        except Exception as e:
            log.debug(u'Не удалось получить код магазина(shopcode_int). Ошибка: %s' % (e))
        try:
            shiftnum_int = int(args['shiftnum'])
        except Exception as e:
            log.debug(u'Не удалось получить номер смены(shiftnum_int). Ошибка: %s' % (e))
        year = Date.today().strftime('%Y')
        short_year = Date.today().strftime('%y')
        month = Date.today().strftime('%m')
        day = Date.today().strftime('%d')
        try:
            string = string % SafeDict(vars())
        except KeyError as e:
            log.error(u'В строке "%s" неизвестно значение параметра %s. Доступные параметры: %s' % (string, e, str(vars())))
        except Exception as e1:
            log.error(u'Ошибка применения макросов в строке "%s". Ошибка: %s' % (string, e1))
    return string


def applyMacros(string, log, **args):
    if isinstance(string, str):
        string = applyMacrosWithoutTime(string, log, **args)
        hour = datetime.now().strftime('%H')
        min = datetime.now().strftime('%M')
        sec = datetime.now().strftime('%S')
        timestamp = int(Time.time()*1000)
        try:
            string = string % SafeDict(vars())
        except KeyError as e:
            log.error(u'В строке "%s" неизвестно значение параметра %s. Доступные параметры: %s' % (string, e, str(vars())))
        except Exception as e1:
            log.error(u'Ошибка применения макросов в строке "%s". Ошибка: %s' % (string, e1))
    return string